<script setup>
import Tabs from 'primevue/tabs';
import TabList from 'primevue/tablist';
import Tab from 'primevue/tab';
import TabPanels from 'primevue/tabpanels';
import TabPanel from 'primevue/tabpanel';
import { computed } from "vue";

const props = defineProps({
  persons: null
});

const designationsSorted = computed(() => {
  return Object.keys(props.persons).sort((a, b) => {
    const aSortingKey = props.persons[a][0].sortingKey ?? 0;
    const bSortingKey = props.persons[b][0].sortingKey ?? 0;
    if (aSortingKey < bSortingKey) return -1;
    else if (aSortingKey > bSortingKey) return 1;
    else return 0;
  });
});

function getDesignationLabel (personsSection) {
  return props.persons[personsSection].length > 1 ? props.persons[personsSection][0].designationPlural : personsSection;
}
</script>
<template>
<Tabs value="0"
  unstyled
  :pt="{
    root: {
      class: 'flex flex-row'
    }
  }"
>
  <TabList 
    unstyled
    :pt="{
      root: {
        class: 'w-1/3 sm:w-1/4'
      },
      content: {
        
      },
      tabList: {
        class: 'flex flex-col flex-wrap items-end',
        ariaOrientation: 'vertical'
      },
    }"
  >
    <Tab 
      v-for="(designation, i) in designationsSorted"
      :value="`${i}`"
      unstyled
      :pt="{
        root: (options) => {
          return {
          class: ['pr-2 sm:pr-4 pb-2 border-r-2 focus:outline-primary-500 hover:text-primary-500 transition-all duration-300 motion-reduce:transition-none', options.context.active ? 'text-primary-500 border-primary-500 ease-in' : 'ease-out']
          }
        }
      }"
    >
      {{ `${getDesignationLabel(designation)} (${persons[designation].length})`}}
    </Tab>
  </TabList>
  <TabPanels unstyled>
    <TabPanel 
      v-for="(designation, i) in designationsSorted" 
      :value="`${i}`"
      unstyled
    >
      <div class="flex flex-col h-full">
        <div class="flex justify-start flex-wrap ml-4 mb-2" v-for="(person, k) in persons[designation]" :key="'person' + k">
          <div :class="{'mr-2': person.from || person.to}" class="text-sm">
            <span v-if="person.from">{{person.from}}</span>
            <span v-if="person.from && person.to"> - </span>
            <span v-if="person.to">{{person.to}}</span>
          </div>
          <a v-if="person.gso" class="text-sm" :href="'https://personendatenbank.germania-sacra.de/index/gsn/' + person.gso" target="_blank">{{person.name}}</a>
          <p v-else class="text-sm">{{person.name}}</p>
        </div>
      </div>
    </TabPanel>
  </TabPanels>
</Tabs>
</template>